/**
 * Yonius 0.1.6.
 *
 * Copyright (c) 2008-2019 Hive Solutions Lda.
 *
 * This source code is licensed under the Apache 2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('node-fetch')) :
  typeof define === 'function' && define.amd ? define(['exports', 'node-fetch'], factory) :
  (global = global || self, factory(global.yonius = {}, global.fetch));
}(this, function (exports, fetch) { 'use strict';

  fetch = fetch && fetch.hasOwnProperty('default') ? fetch['default'] : fetch;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  var Observable =
  /*#__PURE__*/
  function () {
    function Observable() {
      _classCallCheck(this, Observable);

      this.callbacks = {};
    }

    _createClass(Observable, [{
      key: "bind",
      value: function bind(event, callback) {
        var callbacks = this.callbacks[event] || [];
        callbacks.push(callback);
        this.callbacks[event] = callbacks;
        return callback;
      }
    }, {
      key: "unbind",
      value: function unbind(event, callback) {
        var callbacks = this.callbacks[event] || [];

        if (!callback) {
          delete this.callbacks[event];
          return;
        }

        var index = callbacks.indexOf(callback);

        if (index === -1) {
          return;
        }

        callbacks.splice(index, 1);
        this.callbacks[event] = callbacks;
      }
    }, {
      key: "trigger",
      value: function trigger(event) {
        var callbacks = this.callbacks[event] || [];
        var results = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = callbacks[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var callback = _step.value;
            var result = callback.apply(this, Array.prototype.slice.call(arguments, 1));
            result !== undefined && result !== null && results.push(result);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return Promise.all(results);
      }
    }]);

    return Observable;
  }();

  var API =
  /*#__PURE__*/
  function (_Observable) {
    _inherits(API, _Observable);

    function API() {
      _classCallCheck(this, API);

      return _possibleConstructorReturn(this, _getPrototypeOf(API).apply(this, arguments));
    }

    _createClass(API, [{
      key: "get",
      value: function () {
        var _get = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(url) {
          var headers,
              response,
              result,
              _args = arguments;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  headers = _args.length > 1 && _args[1] !== undefined ? _args[1] : null;
                  _context.next = 9;
                  return fetch(url, {
                    method: "GET",
                    headers: headers || {}
                  });

                case 9:
                  response = _context.sent;
                  _context.next = 12;
                  return this._handleResponse(response);

                case 12:
                  result = _context.sent;
                  return _context.abrupt("return", result);

                case 14:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function get(_x) {
          return _get.apply(this, arguments);
        }

        return get;
      }()
    }, {
      key: "_handleResponse",
      value: function () {
        var _handleResponse2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2(response) {
          var result;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  result = null;

                  if (!(response.headers.get("content-type").toLowerCase() === "application/json")) {
                    _context2.next = 7;
                    break;
                  }

                  _context2.next = 4;
                  return response.json();

                case 4:
                  result = _context2.sent;
                  _context2.next = 10;
                  break;

                case 7:
                  _context2.next = 9;
                  return response.blob();

                case 9:
                  result = _context2.sent;

                case 10:
                  return _context2.abrupt("return", result);

                case 11:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        function _handleResponse(_x2) {
          return _handleResponse2.apply(this, arguments);
        }

        return _handleResponse;
      }()
    }]);

    return API;
  }(Observable);

  var OAuthAPI =
  /*#__PURE__*/
  function (_API) {
    _inherits(OAuthAPI, _API);

    function OAuthAPI() {
      _classCallCheck(this, OAuthAPI);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuthAPI).apply(this, arguments));
    }

    return OAuthAPI;
  }(API);

  var OAuth1API =
  /*#__PURE__*/
  function (_OAuthAPI) {
    _inherits(OAuth1API, _OAuthAPI);

    function OAuth1API() {
      _classCallCheck(this, OAuth1API);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuth1API).apply(this, arguments));
    }

    return OAuth1API;
  }(OAuthAPI);

  var OAuth2API =
  /*#__PURE__*/
  function (_OAuthAPI) {
    _inherits(OAuth2API, _OAuthAPI);

    function OAuth2API() {
      _classCallCheck(this, OAuth2API);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuth2API).apply(this, arguments));
    }

    return OAuth2API;
  }(OAuthAPI);

  var verify = function verify(condition) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    if (condition) return;
    message = message || "Verification failed";
    var Exception = exception || Error;
    kwargs = Object.assign({}, kwargs);
    if (message !== null && message !== undefined) kwargs.message = message;
    if (code !== null && message !== undefined) kwargs.code = code;
    var throwable = new Exception(kwargs.message || undefined);
    throwable.kwargs = kwargs;
    throw throwable;
  };
  var verifyEqual = function verifyEqual(first, second) {
    var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    message = message || "Expected ".concat(first, " got ").concat(second);
    return this.verify(first === second, message, code, exception, kwargs);
  };
  var verifyNotEqual = function verifyNotEqual(first, second) {
    var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    message = message || "Expected ".concat(first, " not equal to ").concat(second);
    return this.verify(first !== second, message, code, exception, kwargs);
  };
  var verifyMany = function verifyMany(sequence) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    sequence.forEach(function (element) {
      verify(element, message, code, exception, kwargs);
    });
  };

  var MixinBuilder =
  /*#__PURE__*/
  function () {
    function MixinBuilder(superclass) {
      _classCallCheck(this, MixinBuilder);

      this.superclass = superclass;
    }

    _createClass(MixinBuilder, [{
      key: "with",
      value: function _with() {
        for (var _len = arguments.length, mixins = new Array(_len), _key = 0; _key < _len; _key++) {
          mixins[_key] = arguments[_key];
        }

        return mixins.reduce(function (c, mixin) {
          return mixin(c);
        }, this.superclass);
      }
    }]);

    return MixinBuilder;
  }();
  var mix = function mix(superclass) {
    return new MixinBuilder(superclass);
  };

  var urlEncode = function urlEncode(values) {
    // constructs the parts array that is going to
    // store the multiple and values
    var parts = []; // in case the provided value is not an array
    // then assumes it's an object and retrieve entries

    if (!Array.isArray(values)) {
      values = Object.entries(values);
    } // iterates over the complete set of pairs available
    // from the key value pairs to be able to encode them
    // properly, notice that the values themselves can be
    // sequences allowing multiple repetition of key


    values.forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          key = _ref2[0],
          value = _ref2[1];

      if (!Array.isArray(value)) {
        value = [value];
      }

      var keyEncoded = encodeURIComponent(key);
      value.forEach(function (_value) {
        if (_value === undefined || _value === null) {
          return;
        }

        var valueEncoded = encodeURIComponent(_value);
        parts.push("".concat(keyEncoded, "=").concat(valueEncoded));
      });
    }); // joins the complete set of parts with the and
    // separator and then returns the final string value

    return parts.join("&");
  };

  exports.API = API;
  exports.MixinBuilder = MixinBuilder;
  exports.OAuth1API = OAuth1API;
  exports.OAuth2API = OAuth2API;
  exports.OAuthAPI = OAuthAPI;
  exports.Observable = Observable;
  exports.mix = mix;
  exports.urlEncode = urlEncode;
  exports.verify = verify;
  exports.verifyEqual = verifyEqual;
  exports.verifyMany = verifyMany;
  exports.verifyNotEqual = verifyNotEqual;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=yonius.umd.js.map
